/*----- PROTECTED REGION ID(Agilent4uhv.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Agilent4uhv.cpp,v 1.18 2018-05-10 08:04:51 alessio Exp $";
//=============================================================================
//
// file :        Agilent4uhv.cpp
//
// description : C++ source for the Agilent4uhv class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Agilent4uhv are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.18 $
// $Date: 2018-05-10 08:04:51 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Agilent4uhv.h>
#include <Agilent4uhvClass.h>
#include <iomanip>

/* Commands */
#define HVCH1		  11
#define HVCH2		  12
#define HVCH3		  13
#define HVCH4		  14
//#define BAUDRATE	 108
//#define STATUS		 205
#define ERRORCODE	 206
#define MODEL		 319
#define SERIALNUMBER	 323
//#define RS485ADDRESS	 503
//#define SERIALTYPE	 504
#define SETCHANNEL	 505
#define PRESSUREUNIT	 600
#define OPERATINGMODE	 601
#define PROTECT		 602
#define FIXEDSTEP	 603
#define DEVICENUMBERCH1  610
#define POWERMAXCH1	 612
#define VTARGETCH1	 613
#define IPROTECTCH1	 614
#define SETPOINTCH1	 615
#define DEVICENUMBERCH2	 620
#define POWERMAXCH2	 622
#define VTARGETCH2	 623
#define IPROTECTCH2	 624
#define SETPOINTCH2	 625
#define DEVICENUMBERCH3	 630
#define POWERMAXCH3	 632
#define VTARGETCH3	 633
#define IPROTECTCH3	 634
#define SETPOINTCH3	 635
#define DEVICENUMBERCH4	 640
#define POWERMAXCH4	 642
#define VTARGETCH4	 643
#define IPROTECTCH4	 644
#define SETPOINTCH4	 645
#define TEMPERATUREFAN	 800
#define TEMPERATUREHVCH1 801
#define TEMPERATUREHVCH2 802
#define INTERLOCKSTATUS	 803
#define STATUSSETPOINT	 804
#define TEMPERATUREHVCH3 808
#define TEMPERATUREHVCH4 809
#define VMEASUREDCH1	 810
#define IMEASUREDCH1	 811
#define PRESSURECH1	 812
#define VMEASUREDCH2	 820
#define IMEASUREDCH2	 821
#define PRESSURECH2	 822
#define VMEASUREDCH3	 830
#define IMEASUREDCH3	 831
#define PRESSURECH3	 832
#define VMEASUREDCH4	 840
#define IMEASUREDCH4	 841
#define PRESSURECH4	 842

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv.cpp

/**
 *  Agilent4uhv class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  OffHV1        |  off_hv1
//  OffHV2        |  off_hv2
//  OnHV1         |  on_hv1
//  OnHV2         |  on_hv2
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//  OffHV3        |  off_hv3
//  OffHV4        |  off_hv4
//  OnHV3         |  on_hv3
//  OnHV4         |  on_hv4
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  Model         |  Tango::DevString	Scalar
//  SerialNumber  |  Tango::DevString	Scalar
//  Temperature   |  Tango::DevFloat	Scalar
//================================================================

namespace Agilent4uhv_ns
{
/*----- PROTECTED REGION ID(Agilent4uhv::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::Agilent4uhv()
 *	Description : Constructors for a Tango device
 *                implementing the classAgilent4uhv
 */
//--------------------------------------------------------
Agilent4uhv::Agilent4uhv(Tango::DeviceClass *cl, string &s)
 : Serial2Client(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Agilent4uhv::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::constructor_1
}
//--------------------------------------------------------
Agilent4uhv::Agilent4uhv(Tango::DeviceClass *cl, const char *s)
 : Serial2Client(cl, s)
{
	/*----- PROTECTED REGION ID(Agilent4uhv::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::constructor_2
}
//--------------------------------------------------------
Agilent4uhv::Agilent4uhv(Tango::DeviceClass *cl, const char *s, const char *d)
 : Serial2Client(cl, s, d)
{
	/*----- PROTECTED REGION ID(Agilent4uhv::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Agilent4uhv::delete_device()
{
	DEBUG_STREAM << "Agilent4uhv::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	if (worker) {
		worker->stop();
		worker->join(NULL);
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::delete_device

	if (Tango::Util::instance()->is_svr_shutting_down()==false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false &&
		Tango::Util::instance()->is_svr_starting()==false)
	{
		//	If not shutting down call delete device for inherited object
		Serial2Client_ns::Serial2Client::delete_device();
	}
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Agilent4uhv::init_device()
{
	DEBUG_STREAM << "Agilent4uhv::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	mandatoryNotDefined = false;
	nchannel = 0;
	odd_channel_quirk = false;
	init_error.clear();

	worker = NULL;

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::init_device_before
	
	if (Tango::Util::instance()->is_svr_starting() == false  &&
		Tango::Util::instance()->is_device_restarting(device_name)==false)
	{
		//	If not starting up call init device for inherited object
		Serial2Client_ns::Serial2Client::init_device();
	}
	//	No device property to be read from database
	
	//	No longer if mandatory property not set. 
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(Agilent4uhv::init_device) ENABLED START -----*/
	
	//	Initialize device
	try {
		string model;
		read(MODEL, model);
		model.erase(remove(model.begin(), model.end(), ' '), model.end());

		if (model == "9299010" || model == "9299011"
				|| model == "9299100" || model == "9299101")
			nchannel = 1;
		else if (model == "9299020" || model == "9299021"
				|| model == "9299200" || model == "9299201"
				|| model == "9299022")
			nchannel = 2;
		else if (model == "9299210" || model == "9299211"
				|| model == "9299212" || model == "9299213")
			nchannel = 3;
		else if (model == "9299400" || model == "9299401"
				|| model == "9299402")
			nchannel = 4;
		else
			Tango::Except::throw_exception( "",
					"Unknown model",
					"Agilent4uhv::init_device()");

		Tango::DevUShort powermax;
		read(POWERMAXCH1, powermax);
		if (powermax == 200)
			odd_channel_quirk = true;

		int unit;
		read(PRESSUREUNIT, unit);
		if (unit != 1)
 			Tango::Except::throw_exception( "",
 					"Pressure unit is wrong",
 					"Agilent4uhv::init_device()");
 
		data.state = Tango::INIT;
		data.status = "The device is in INIT state";

 		worker = new Worker(this);
 		worker->start();
		
	} catch(Tango::DevFailed &e) {
		init_error = "Initialization failed: " + string(e.errors[0].desc);
		set_state(Tango::FAULT);
	} catch (...) {
		init_error =	"Initialization failed: Unknown error";
		set_state(Tango::UNKNOWN);
	}

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::init_device
}


//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Agilent4uhv::always_executed_hook()
{
	DEBUG_STREAM << "Agilent4uhv::always_executed_hook()  " << device_name << endl;
	if (mandatoryNotDefined)
	{
		string	status(get_status());
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					status.c_str(),
					(const char *)"Agilent4uhv::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(Agilent4uhv::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	if (! init_error.empty()) {
		set_state(Tango::FAULT);
		set_status(init_error);
		return;
	}

	data_mutex.lock();
	set_state(data.state);
	set_status(data.status);
	data_mutex.unlock();

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Agilent4uhv::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Agilent4uhv::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	check_init_error();
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Model related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_Model(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_Model(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::read_Model) ENABLED START -----*/

	Tango::DevString *model = new Tango::DevString();

	data_mutex.lock();
	*model = CORBA::string_dup(data.model.c_str());
	data_mutex.unlock();

	attr.set_value(model, 1, 0, true);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_Model
}
//--------------------------------------------------------
/**
 *	Read attribute SerialNumber related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_SerialNumber(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_SerialNumber(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::read_SerialNumber) ENABLED START -----*/

	Tango::DevString *serial_number = new Tango::DevString();

	data_mutex.lock();
	*serial_number = CORBA::string_dup(data.serial_number.c_str());
	data_mutex.unlock();

	attr.set_value(serial_number, 1, 0, true);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_SerialNumber
}
//--------------------------------------------------------
/**
 *	Read attribute Temperature related method
 *	Description: 
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_Temperature(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_Temperature(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::read_Temperature) ENABLED START -----*/

	Tango::DevFloat *temperature = new Tango::DevFloat();

	data_mutex.lock();
	*temperature = data.temperature_fan;
	data_mutex.unlock();

	attr.set_value(temperature, 1, 0, true);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_Temperature
}

//--------------------------------------------------------
/**
 *	Read attribute HVX related method
 *	Description: 
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_HVX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_HVX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevState	*att_value = get_HVX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_HVX) ENABLED START -----*/
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	int value;

	data_mutex.lock();
	value = data.hvch[indexn-1];
	data_mutex.unlock();

	if (value)
		*att_value = Tango::ON;
	else
		*att_value = Tango::OFF;
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_HVX
}
//--------------------------------------------------------
/**
 *	Read attribute DeviceNumberX related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_DeviceNumberX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_DeviceNumberX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevLong	*att_value = get_DeviceNumberX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_DeviceNumberX) ENABLED START -----*/
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	
	data_mutex.lock();
	*att_value = data.device_number[indexn-1];
	data_mutex.unlock();

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_DeviceNumberX
}
//--------------------------------------------------------
/**
 *	Write attribute DeviceNumberX related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_DeviceNumberX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_DeviceNumberX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevLong	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_DeviceNumberX) ENABLED START -----*/
	
	check_init_error();

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	switch (indexn)
	{
		case 1:
			write(DEVICENUMBERCH1, w_val);
			break;
		case 2:
			write(DEVICENUMBERCH2, w_val);
			break;
		case 3:
			write(DEVICENUMBERCH3, w_val);
			break;
		case 4:
			write(DEVICENUMBERCH4, w_val);
			break;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_DeviceNumberX
}
//--------------------------------------------------------
/**
 *	Read attribute PowerMaxX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_PowerMaxX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_PowerMaxX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevUShort	*att_value = get_PowerMaxX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_PowerMaxX) ENABLED START -----*/
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	
	data_mutex.lock();
	*att_value = data.power_max[indexn-1];
	data_mutex.unlock();

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_PowerMaxX
}
//--------------------------------------------------------
/**
 *	Write attribute PowerMaxX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_PowerMaxX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_PowerMaxX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_PowerMaxX) ENABLED START -----*/
	
	check_init_error();

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	switch (indexn)
	{
		case 1:
			write(POWERMAXCH1, w_val);
			break;
		case 2:
			write(POWERMAXCH2, w_val);
			break;
		case 3:
			write(POWERMAXCH3, w_val);
			break;
		case 4:
			write(POWERMAXCH4, w_val);
			break;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_PowerMaxX
}
//--------------------------------------------------------
/**
 *	Read attribute VTargetX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_VTargetX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_VTargetX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevUShort	*att_value = get_VTargetX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_VTargetX) ENABLED START -----*/
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	
	data_mutex.lock();
	*att_value = data.vtarget[indexn-1];
	data_mutex.unlock();

	*att_value /= 1000;
	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_VTargetX
}
//--------------------------------------------------------
/**
 *	Write attribute VTargetX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_VTargetX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_VTargetX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_VTargetX) ENABLED START -----*/
	
	check_init_error();

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	w_val *= 1000;
	switch (indexn)
	{
		case 1:
			write(VTARGETCH1, w_val);
			break;
		case 2:
			write(VTARGETCH2, w_val);
			break;
		case 3:
			write(VTARGETCH3, w_val);
			break;
		case 4:
			write(VTARGETCH4, w_val);
			break;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_VTargetX
}
//--------------------------------------------------------
/**
 *	Read attribute IProtectX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_IProtectX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_IProtectX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevUShort	*att_value = get_IProtectX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_IProtectX) ENABLED START -----*/
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	
	data_mutex.lock();
	*att_value = data.iprotect[indexn-1];
	data_mutex.unlock();

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_IProtectX
}
//--------------------------------------------------------
/**
 *	Write attribute IProtectX related method
 *	Description: 
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_IProtectX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_IProtectX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevUShort	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_IProtectX) ENABLED START -----*/
	
	check_init_error();

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	switch (indexn)
	{
		case 1:
			write(IPROTECTCH1, w_val);
			break;
		case 2:
			write(IPROTECTCH2, w_val);
			break;
		case 3:
			write(IPROTECTCH3, w_val);
			break;
		case 4:
			write(IPROTECTCH4, w_val);
			break;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_IProtectX
}
//--------------------------------------------------------
/**
 *	Read attribute SetPointX related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_SetPointX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_SetPointX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevDouble	*att_value = get_SetPointX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_SetPointX) ENABLED START -----*/
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	
	data_mutex.lock();
	*att_value = data.setpoint[indexn-1];
	data_mutex.unlock();

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_SetPointX
}
//--------------------------------------------------------
/**
 *	Write attribute SetPointX related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_SetPointX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_SetPointX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_SetPointX) ENABLED START -----*/

	check_init_error();

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	stringstream ss;
	ss.precision(1);
	ss << scientific << uppercase << w_val << flush;
	string w_val_s;
	w_val_s = ss.str();
	switch (indexn)
	{
		case 1:
			write(SETPOINTCH1, w_val_s);
			break;
		case 2:
			write(SETPOINTCH2, w_val_s);
			break;
		case 3:
			write(SETPOINTCH3, w_val_s);
			break;
		case 4:
			write(SETPOINTCH4, w_val_s);
			break;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_SetPointX
}
//--------------------------------------------------------
/**
 *	Read attribute TemperatureHVX related method
 *	Description: 
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_TemperatureHVX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_TemperatureHVX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevFloat	*att_value = get_TemperatureHVX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_TemperatureHVX) ENABLED START -----*/
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	
	data_mutex.lock();
	*att_value = data.temperaturehv[indexn-1];
	data_mutex.unlock();

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_TemperatureHVX
}
//--------------------------------------------------------
/**
 *	Read attribute VoltageX related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_VoltageX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_VoltageX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevDouble	*att_value = get_VoltageX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_VoltageX) ENABLED START -----*/
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	
	data_mutex.lock();
	*att_value = data.vmeasured[indexn-1];
	data_mutex.unlock();

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_VoltageX
}
//--------------------------------------------------------
/**
 *	Read attribute CurrentX related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_CurrentX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_CurrentX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevDouble	*att_value = get_CurrentX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_CurrentX) ENABLED START -----*/
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	
	data_mutex.lock();
	*att_value = data.imeasured[indexn-1];
	data_mutex.unlock();

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_CurrentX
}
//--------------------------------------------------------
/**
 *	Read attribute PressureX related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_PressureX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_PressureX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevDouble	*att_value = get_PressureX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_PressureX) ENABLED START -----*/
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);
	
	data_mutex.lock();
	*att_value = data.pressure[indexn-1];
	data_mutex.unlock();

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_PressureX
}
//--------------------------------------------------------
/**
 *	Read attribute StateX related method
 *	Description: 
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_StateX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_StateX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevState	*att_value = get_StateX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_StateX) ENABLED START -----*/
	//	Set the attribute value

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> errcodes;

	data_mutex.lock();
	int value = data.hvch[indexn-1];
	errcodes = data.ec;
	data_mutex.unlock();

	switch(value)
	{
		case 0:
			*att_value = Tango::OFF;
			break;
		case 1:
			*att_value = Tango::ON;
			break;
		default:
			assert(false);
	}

	if (errcodes[6-indexn] != '0')
		*att_value = Tango::FAULT;
	
	attr.set_value(att_value);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_StateX
}
//--------------------------------------------------------
/**
 *	Read attribute StatusX related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_StatusX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_StatusX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevString	*att_value = get_StatusX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_StatusX) ENABLED START -----*/
	//	Set the attribute value

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> errcodes;

	data_mutex.lock();
	int value = data.hvch[indexn-1];
	errcodes = data.ec;
	data_mutex.unlock();

	string status;
	switch(value)
	{
		case 0:
			status = "The device is in OFF state";
			break;
		case 1:
			status = "The device is in ON state";
			break;
		default:
			assert(false);
	}

	int errcode = (int)errcodes[6-indexn] - 48;

	if (errcode != 0)
	{
		status = "";

		if (errcode & 0x1)
			status += "FAN error ";
		if (errcode & 0x2)
			status += "Power input error from HV ";
		if (errcode & 0x4)
			status += "Power input error from PFC ";
		if (errcode & 0x8)
			status += "Overtemp PFC ";
		if (errcode & 0x10)
			status += "Error communication CPU-HV ";
		if (errcode & 0x20)
			status += "Interlock cable ";
		if (errcode & 0x40)
			status += "Overtemp HV ";
		if (errcode & 0x80)
			status += "Protect ";
		if (errcode & 0x100)
			status += "Measurement error ";
		if (errcode & 0x200)
			status += "HV out error ";
		if (errcode & 0x400)
			status += "Short circuit ";
		if (errcode & 0x800)
			status += "HV disabled ";

	}

	if (*att_value != NULL)
		CORBA::string_free(*att_value);
	*att_value = CORBA::string_dup(status.c_str());

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_StatusX
}
//--------------------------------------------------------
/**
 *	Read attribute AutoStartX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_AutoStartX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_AutoStartX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevBoolean	*att_value = get_AutoStartX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_AutoStartX) ENABLED START -----*/
	//	Set the attribute value
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> autostart;
	data_mutex.lock();
	autostart = data.autostart;
	data_mutex.unlock();

	if (autostart[10-indexn] == '0')
		*att_value = false;
	else
		*att_value = true;

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_AutoStartX
}
//--------------------------------------------------------
/**
 *	Write attribute AutoStartX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_AutoStartX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_AutoStartX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_AutoStartX) ENABLED START -----*/

	check_init_error();

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> autostart;
	data_mutex.lock();
	autostart = data.autostart;
	data_mutex.unlock();

	if (w_val)
		autostart[10-indexn] = '1';
	else
		autostart[10-indexn] = '0';

	write(OPERATINGMODE, autostart);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_AutoStartX
}
//--------------------------------------------------------
/**
 *	Read attribute ProtectX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_ProtectX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_ProtectX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevBoolean	*att_value = get_ProtectX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_ProtectX) ENABLED START -----*/
	//	Set the attribute value
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> protect;
	data_mutex.lock();
	protect = data.protect;
	data_mutex.unlock();

	if (protect[10-indexn] == '0')
		*att_value = false;
	else
		*att_value = true;

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_ProtectX
}
//--------------------------------------------------------
/**
 *	Write attribute ProtectX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_ProtectX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_ProtectX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_ProtectX) ENABLED START -----*/

	check_init_error();

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> protect;
	data_mutex.lock();
	protect = data.protect;
	data_mutex.unlock();

	if (w_val)
		protect[10-indexn] = '1';
	else
		protect[10-indexn] = '0';

	write(PROTECT, protect);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_ProtectX
}
//--------------------------------------------------------
/**
 *	Read attribute FixedStepX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_FixedStepX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_FixedStepX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevBoolean	*att_value = get_FixedStepX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_FixedStepX) ENABLED START -----*/
	//	Set the attribute value
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> fs;
	data_mutex.lock();
	fs = data.fs;
	data_mutex.unlock();

	if (fs[10-indexn] == '0')
		*att_value = true;
	else
		*att_value = false;

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_FixedStepX
}
//--------------------------------------------------------
/**
 *	Write attribute FixedStepX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::write_FixedStepX(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::write_FixedStepX(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Agilent4uhv::write_FixedStepX) ENABLED START -----*/

	check_init_error();

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> fs;
	data_mutex.lock();
	fs = data.fs;
	data_mutex.unlock();

	if (w_val)
		fs[10-indexn] = '0';
	else
		fs[10-indexn] = '1';

	write(FIXEDSTEP, fs);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::write_FixedStepX
}
//--------------------------------------------------------
/**
 *	Read attribute StatusSetPointX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_StatusSetPointX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_StatusSetPointX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevBoolean	*att_value = get_StatusSetPointX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_StatusSetPointX) ENABLED START -----*/
	//	Set the attribute value
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> ssp;
	data_mutex.lock();
	ssp = data.ssp;
	data_mutex.unlock();

	if (ssp[10-indexn] == '0')
		*att_value = false;
	else
		*att_value = true;

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_StatusSetPointX
}
//--------------------------------------------------------
/**
 *	Read attribute InterlockStatusX related method
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_InterlockStatusX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_InterlockStatusX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevBoolean	*att_value = get_InterlockStatusX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_InterlockStatusX) ENABLED START -----*/
	//	Set the attribute value
	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> is;
	data_mutex.lock();
	is = data.is;
	data_mutex.unlock();

	if (is[10-indexn] == '0')
		*att_value = false;
	else
		*att_value = true;

	attr.set_value(att_value);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_InterlockStatusX
}
//--------------------------------------------------------
/**
 *	Read attribute StatMaskX related method
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Agilent4uhv::read_StatMaskX(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Agilent4uhv::read_StatMaskX(Tango::Attribute &attr) entering... " << endl;
	Tango::DevLong	*att_value = get_StatMaskX_data_ptr(attr.get_name());
	/*----- PROTECTED REGION ID(Agilent4uhv::read_StatMaskX) ENABLED START -----*/
	//	Set the attribute value

	Tango::DevUShort indexn;
	convert(attr.get_name().substr(attr.get_name().size()-1), indexn);

	vector<unsigned char> errcodes;
	vector<unsigned char> fs;
	
	data_mutex.lock();
	int value = data.hvch[indexn-1];
	errcodes = data.ec;
	fs = data.fs;
	data_mutex.unlock();

	*att_value = 0;
	switch(value)
	{
		case 0:
			break;
		case 1:
			*att_value |= 0x1;
			break;
		default:
			assert(false);
	}

	// FIXME How provides locale/remote bit (1)?
	*att_value |= 0x1 << 1;

	if (errcodes[6-indexn] != '0')
		*att_value |= 0x1 << 2;

	if (fs[10-indexn] == '1')
		*att_value |= 0x1 << 3;

	// FIXME bit 4,5,6 and 7 aren't implemented
	
	attr.set_value(att_value);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::read_StatMaskX
}
//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Agilent4uhv::add_dynamic_attributes()
{
	//	Example to add dynamic attribute:
	//	Copy inside the following protected area to create instance(s) at startup.
	//	add_HVX_dynamic_attribute("MyHVXAttribute");
	//	add_DeviceNumberX_dynamic_attribute("MyDeviceNumberXAttribute");
	//	add_PowerMaxX_dynamic_attribute("MyPowerMaxXAttribute");
	//	add_VTargetX_dynamic_attribute("MyVTargetXAttribute");
	//	add_IProtectX_dynamic_attribute("MyIProtectXAttribute");
	//	add_SetPointX_dynamic_attribute("MySetPointXAttribute");
	//	add_TemperatureHVX_dynamic_attribute("MyTemperatureHVXAttribute");
	//	add_VoltageX_dynamic_attribute("MyVoltageXAttribute");
	//	add_CurrentX_dynamic_attribute("MyCurrentXAttribute");
	//	add_PressureX_dynamic_attribute("MyPressureXAttribute");
	//	add_StateX_dynamic_attribute("MyStateXAttribute");
	//	add_StatusX_dynamic_attribute("MyStatusXAttribute");
	//	add_AutoStartX_dynamic_attribute("MyAutoStartXAttribute");
	//	add_ProtectX_dynamic_attribute("MyProtectXAttribute");
	//	add_FixedStepX_dynamic_attribute("MyFixedStepXAttribute");
	//	add_StatusSetPointX_dynamic_attribute("MyStatusSetPointXAttribute");
	//	add_InterlockStatusX_dynamic_attribute("MyInterlockStatusXAttribute");
	//	add_StatMaskX_dynamic_attribute("MyStatMaskXAttribute");
	
	/*----- PROTECTED REGION ID(Agilent4uhv::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	for (unsigned short cn=1; cn <= nchannel; ++cn)
	{
		stringstream ssname;
		string sname;
		int i = cn;

		if (odd_channel_quirk && cn > 1)
			++i;

		ssname.str(""); ssname.clear();
		ssname << "HV" << i << flush;
		sname = ssname.str();
		add_HVX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "DeviceNumber" << i << flush;
		sname = ssname.str();
		add_DeviceNumberX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "PowerMax" << i << flush;
		sname = ssname.str();
		add_PowerMaxX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "VTarget" << i << flush;
		sname = ssname.str();
		add_VTargetX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "IProtect" << i << flush;
		sname = ssname.str();
		add_IProtectX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "SetPoint" << i << flush;
		sname = ssname.str();
		add_SetPointX_dynamic_attribute(sname);
		
		ssname.str(""); ssname.clear();
		ssname << "TemperatureHV" << i << flush;
		sname = ssname.str();
		add_TemperatureHVX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Voltage" << i << flush;
		sname = ssname.str();
		add_VoltageX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Current" << i << flush;
		sname = ssname.str();
		add_CurrentX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Pressure" << i << flush;
		sname = ssname.str();
		add_PressureX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "State" << i << flush;
		sname = ssname.str();
		add_StateX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Status" << i << flush;
		sname = ssname.str();
		add_StatusX_dynamic_attribute(sname);
		Tango::DevString *att_value = get_StatusX_data_ptr(sname);
		*att_value = NULL; 

		ssname.str(""); ssname.clear();
		ssname << "AutoStart" << i << flush;
		sname = ssname.str();
		add_AutoStartX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Protect" << i << flush;
		sname = ssname.str();
		add_ProtectX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "Fixed" << i << flush;
		sname = ssname.str();
		add_FixedStepX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "StatusSetPoint" << i << flush;
		sname = ssname.str();
		add_StatusSetPointX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "InterlockStatus" << i << flush;
		sname = ssname.str();
		add_InterlockStatusX_dynamic_attribute(sname);

		ssname.str(""); ssname.clear();
		ssname << "StatMask" << i << flush;
		sname = ssname.str();
		add_StatMaskX_dynamic_attribute(sname);
	}
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command OffHV1 related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Agilent4uhv::off_hv1()
{
	DEBUG_STREAM << "Agilent4uhv::OffHV1()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::off_hv1) ENABLED START -----*/
	
	//	Add your own code
	check_init_error();

	int new_state = 0;
	write(HVCH1, new_state);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::off_hv1
}
//--------------------------------------------------------
/**
 *	Command OffHV2 related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Agilent4uhv::off_hv2()
{
	DEBUG_STREAM << "Agilent4uhv::OffHV2()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::off_hv2) ENABLED START -----*/
	
	//	Add your own code
	check_init_error();
	
	int new_state = 0;
	write(HVCH2, new_state);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::off_hv2
}
//--------------------------------------------------------
/**
 *	Command OnHV1 related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Agilent4uhv::on_hv1()
{
	DEBUG_STREAM << "Agilent4uhv::OnHV1()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::on_hv1) ENABLED START -----*/
	
	//	Add your own code
	check_init_error();
	
	int new_state = 1;
	write(HVCH1, new_state);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::on_hv1
}
//--------------------------------------------------------
/**
 *	Command OnHV2 related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Agilent4uhv::on_hv2()
{
	DEBUG_STREAM << "Agilent4uhv::OnHV2()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::on_hv2) ENABLED START -----*/
	
	//	Add your own code
	check_init_error();
	
	int new_state = 1;
	write(HVCH2, new_state);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::on_hv2
}
//--------------------------------------------------------
/**
 *	Command OffHV3 related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Agilent4uhv::off_hv3()
{
	DEBUG_STREAM << "Agilent4uhv::OffHV3()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::off_hv3) ENABLED START -----*/
	
	//	Add your own code
	check_init_error();
	
	int new_state = 0;
	write(HVCH3, new_state);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::off_hv3
}
//--------------------------------------------------------
/**
 *	Command OffHV4 related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Agilent4uhv::off_hv4()
{
	DEBUG_STREAM << "Agilent4uhv::OffHV4()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::off_hv4) ENABLED START -----*/
	
	//	Add your own code
	check_init_error();
	
	int new_state = 0;
	write(HVCH4, new_state);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::off_hv4
}
//--------------------------------------------------------
/**
 *	Command OnHV3 related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Agilent4uhv::on_hv3()
{
	DEBUG_STREAM << "Agilent4uhv::OnHV3()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::on_hv3) ENABLED START -----*/
	
	//	Add your own code
	check_init_error();
	
	int new_state = 1;
	write(HVCH3, new_state);
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::on_hv3
}
//--------------------------------------------------------
/**
 *	Command OnHV4 related method
 *	Description: 
 *
 */
//--------------------------------------------------------
void Agilent4uhv::on_hv4()
{
	DEBUG_STREAM << "Agilent4uhv::OnHV4()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Agilent4uhv::on_hv4) ENABLED START -----*/
	
	//	Add your own code
	check_init_error();
	
	int new_state = 1;
	write(HVCH4, new_state);

	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::on_hv4
}
//--------------------------------------------------------
/**
 *	Method      : Agilent4uhv::add_dynamic_commands()
 *	Description : Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Agilent4uhv::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Agilent4uhv::add_dynamic_commands) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic commands if any
	
	/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Agilent4uhv::namespace_ending) ENABLED START -----*/

//	Additional Methods

#define STX 0x02
#define ADDR 0x80
#define ETX 0x03
#define WIN_LENGTH 3
#define CRC_LENGTH 2
#define READ_WINDOW 0x30
#define WRITE_WINDOW 0x31

void Agilent4uhv::write(const int win, string &value)
{
	vector<unsigned char> data;

	for (unsigned int i=0; i<value.size(); ++i)
		data.push_back(value[i]);

	write(win, data);

	DEBUG_STREAM << "Written " << value.size() << " byte(s): "
		<< value << endl;
}

void Agilent4uhv::read(const int win, string &value)
{
	vector<unsigned char> answer;

	read(win, answer);

	stringstream ss;
	for (unsigned int i=0; i<answer.size(); ++i)
		ss << (char)answer[i];
	ss << flush;
	value = ss.str();

	DEBUG_STREAM << "Readed " << value.size() << " byte(s): "
		<< value << endl;
}

void Agilent4uhv::write(const int win, vector<unsigned char> &data)
{
	stringstream win_ss;
	win_ss.width(WIN_LENGTH);
	win_ss.fill('0');
	win_ss << win << flush;
	string win_s;
	win_ss >> win_s;
	if (win_ss.fail())
		Tango::Except::throw_exception( "",
				"Conversion fail " + win_ss.str(),
				"Agilent4uhv::write()");

	vector<unsigned char> discarded;

	iomutex.lock();
	try {
		write_message(win_s, WRITE_WINDOW, data);
		read_answer(win_s, WRITE_WINDOW, discarded);
		iomutex.unlock();
	} catch(...) {
		iomutex.unlock();
		throw;
	}
}

void Agilent4uhv::read(const int win, vector<unsigned char> &answer)
{
	stringstream win_ss;
	win_ss.width(WIN_LENGTH);
	win_ss.fill('0');
	win_ss << win << flush;
	string win_s;
	win_ss >> win_s;
	if (win_ss.fail())
		Tango::Except::throw_exception( "",
				"Conversion fail " + win_ss.str(),
				"Agilent4uhv::read()");

	vector<unsigned char> discarded;

	iomutex.lock();
	try {
		write_message(win_s, READ_WINDOW, discarded);
		read_answer(win_s, READ_WINDOW, answer);
		iomutex.unlock();
	} catch(...) {
		iomutex.unlock();
		throw;
	}
}

//	Message:
//	<STX>+<ADDR>+<WIN>+<COM>+<DATA>+<ETX>+<CRC>
void Agilent4uhv::write_message(const string win_s, const unsigned char com,
		vector<unsigned char> &data)
{
	vector<unsigned char> message;

	message.push_back(STX);
	message.push_back(ADDR);

	for (int i=0; i<WIN_LENGTH; ++i)
		message.push_back(win_s[i]);

	message.push_back(com);

	for (vector<char>::size_type i=0; i<data.size(); ++i)
		message.push_back(data[i]);

	message.push_back(ETX);
	unsigned char crc_ = calc_crc(message);

	stringstream crc_ss;
	crc_ss.width(CRC_LENGTH);
	crc_ss.fill('0');
	crc_ss << hex << uppercase << (int)crc_ << flush;
	string crc_s;
	crc_ss >> crc_s;
	if (crc_ss.fail())
		Tango::Except::throw_exception( "",
				"Conversion fail " + crc_ss.str(),
				"Agilent4uhv::write_message()");

	for (int i=0; i<CRC_LENGTH; ++i)
		message.push_back(crc_s[i]);

	Serial2Client::write(message);
}

void Agilent4uhv::read_answer(const string win_s, const unsigned char com,
		vector<unsigned char> &answer)
{
	vector<unsigned char> answer_, crc;
	Serial2Client::read_until(ETX, answer_);
	Serial2Client::read(2, crc);

	if (answer_.size() == 4)
	{
		// Thus data is 1 byte length and it could be an error or Logic datatype!

		string err_mesg;
		switch ((int)answer_[2])
		{
			case 0x06:
				// Ok
				return;
			case 0x15:
				err_mesg = "Execution of the command has failed";
				break;
			case 0x32:
				err_mesg = "The window specified in the command is not a valid window";
				break;
			case 0x33:
				err_mesg = "The data type specified in the command (Logic, Numeric or "
					"Alphanumeric) is not in agreement with the Window specified";
				break;
			case 0x35:
				err_mesg = "The window specified is Read Only or is temporarily disabled";
				break;
		}

		if (! err_mesg.empty())
			Tango::Except::throw_exception( "",
					err_mesg,
					"Agilent4uhv::read_answer()");
	}

	stringstream win_rr;
	win_rr << answer_[2] << answer_[3] << answer_[4] << flush;
	string win_r;
	win_rr >> win_r;
	if (win_rr.fail())
		Tango::Except::throw_exception( "",
				"Conversion fail " + win_rr.str(),
				"Agilent4uhv::read_answer()");

	unsigned char crc_c = calc_crc(answer_);

	stringstream crc_rr;
	crc_rr << hex << uppercase << crc[0] << crc[1] << flush;	
	int crc_r;
	crc_rr >> crc_r;
	if (crc_rr.fail())
		Tango::Except::throw_exception( "",
				"Conversion fail " + crc_rr.str(),
				"Agilent4uhv::read_answer()");

	if (answer_[0] != STX /*|| answer_[1] != ADDR + 1*/ || com != answer_[5]
			|| win_s != win_r || crc_c != crc_r)
		Tango::Except::throw_exception( "",
				"Answer malformed",
				"Agilent4uhv::read_answer()");

	answer.resize(answer_.size() - 7);
	copy(answer_.begin() + 6, answer_.end() - 1, answer.begin());
}

unsigned char Agilent4uhv::calc_crc(const vector<unsigned char> &message)
{
	unsigned char ret = 0;
	for (vector<unsigned char>::size_type i=1 /*Skip STX*/; i<message.size(); ++i)
		ret ^= message[i];
	return ret;
}

void Agilent4uhv::check_init_error(void)
{
	if (! init_error.empty())
		Tango::Except::throw_exception( "",
			init_error.c_str(),
			"Agilent4uhv::check_init_error()");
}

void* Worker::run_undetached(void *ptr)
{
	(void)ptr;

	DEBUG_STREAM << "Worker::run_undetached() - enter" << endl;

	Data data;
	vector<unsigned char> channels(6, '0');

	while(cont) {
		DEBUG_STREAM << "Worker::run_undetached() - loop" << endl;

		// Retrieve data
		try {
			device->read(MODEL, data.model);
			if(! cont)
				break;
			wait(10);

			device->read(SERIALNUMBER, data.serial_number);
			if(! cont)
				break;
			wait(10);

			device->read(TEMPERATUREFAN, data.temperature_fan);
			if(! cont)
				break;
			wait(10);

			device->read(HVCH1, data.hvch[0]);
			if(! cont)
				break;
			wait(10);

			device->read(HVCH2, data.hvch[1]);
			if(! cont)
				break;
			wait(10);

			device->read(HVCH3, data.hvch[2]);
			if(! cont)
				break;
			wait(10);

			device->read(HVCH4, data.hvch[3]);
			if(! cont)
				break;
			wait(10);

			device->read(DEVICENUMBERCH1, data.device_number[0]);
			if(! cont)
				break;
			wait(10);

			device->read(DEVICENUMBERCH2, data.device_number[1]);
			if(! cont)
				break;
			wait(10);

			device->read(DEVICENUMBERCH3, data.device_number[2]);
			if(! cont)
				break;
			wait(10);

			device->read(DEVICENUMBERCH4, data.device_number[3]);
			if(! cont)
				break;
			wait(10);

			device->read(POWERMAXCH1, data.power_max[0]);
			if(! cont)
				break;
			wait(10);

			device->read(POWERMAXCH2, data.power_max[1]);
			if(! cont)
				break;
			wait(10);

			device->read(POWERMAXCH3, data.power_max[2]);
			if(! cont)
				break;
			wait(10);

			device->read(POWERMAXCH4, data.power_max[3]);
			if(! cont)
				break;
			wait(10);

			device->read(VTARGETCH1, data.vtarget[0]);
			if(! cont)
				break;
			wait(10);

			device->read(VTARGETCH2, data.vtarget[1]);
			if(! cont)
				break;
			wait(10);

			device->read(VTARGETCH3, data.vtarget[2]);
			if(! cont)
				break;
			wait(10);

			device->read(VTARGETCH4, data.vtarget[3]);
			if(! cont)
				break;
			wait(10);

			device->read(IPROTECTCH1, data.iprotect[0]);
			if(! cont)
				break;
			wait(10);

			device->read(IPROTECTCH2, data.iprotect[1]);
			if(! cont)
				break;
			wait(10);

			device->read(IPROTECTCH3, data.iprotect[2]);
			if(! cont)
				break;
			wait(10);

			device->read(IPROTECTCH4, data.iprotect[3]);
			if(! cont)
				break;
			wait(10);

			device->read(SETPOINTCH1, data.setpoint[0]);
			if(! cont)
				break;
			wait(10);

			device->read(SETPOINTCH2, data.setpoint[1]);
			if(! cont)
				break;
			wait(10);

			device->read(SETPOINTCH3, data.setpoint[2]);
			if(! cont)
				break;
			wait(10);

			device->read(SETPOINTCH4, data.setpoint[3]);
			if(! cont)
				break;
			wait(10);

			device->read(TEMPERATUREHVCH1, data.temperaturehv[0]);
			if(! cont)
				break;
			wait(10);

			device->read(TEMPERATUREHVCH2, data.temperaturehv[1]);
			if(! cont)
				break;
			wait(10);

			device->read(TEMPERATUREHVCH3, data.temperaturehv[2]);
			if(! cont)
				break;
			wait(10);

			device->read(TEMPERATUREHVCH4, data.temperaturehv[3]);
			if(! cont)
				break;
			wait(10);

			device->read(VMEASUREDCH1, data.vmeasured[0]);
			if(! cont)
				break;
			wait(10);

			device->read(VMEASUREDCH2, data.vmeasured[1]);
			if(! cont)
				break;
			wait(10);

			device->read(VMEASUREDCH3, data.vmeasured[2]);
			if(! cont)
				break;
			wait(10);

			device->read(VMEASUREDCH4, data.vmeasured[3]);
			if(! cont)
				break;
			wait(10);

			device->read(IMEASUREDCH1, data.imeasured[0]);
			if(! cont)
				break;
			wait(10);

			device->read(IMEASUREDCH2, data.imeasured[1]);
			if(! cont)
				break;
			wait(10);

			device->read(IMEASUREDCH3, data.imeasured[2]);
			if(! cont)
				break;
			wait(10);

			device->read(IMEASUREDCH4, data.imeasured[3]);
			if(! cont)
				break;
			wait(10);

			device->read(PRESSURECH1, data.pressure[0]);
			if(! cont)
				break;
			wait(10);

			device->read(PRESSURECH2, data.pressure[1]);
			if(! cont)
				break;
			wait(10);

			device->read(PRESSURECH3, data.pressure[2]);
			if(! cont)
				break;
			wait(10);

			device->read(PRESSURECH4, data.pressure[3]);
			if(! cont)
				break;
			wait(10);

			device->read(OPERATINGMODE, data.autostart);
			if(! cont)
				break;
			wait(10);

			device->read(PROTECT, data.protect);
			if(! cont)
				break;
			wait(10);

			device->read(FIXEDSTEP, data.fs);
			if(! cont)
				break;
			wait(10);

			device->read(STATUSSETPOINT, data.ssp);
			if(! cont)
				break;
			wait(10);

			device->read(INTERLOCKSTATUS, data.is);
			if(! cont)
				break;
			wait(10);

			device->write(SETCHANNEL, channels);
			device->read(ERRORCODE, data.ec);
			if(! cont)
				break;
			wait(10);

			data.state = Tango::ON;
			data.status = "The device is in ON state";
		} catch(Tango::DevFailed &e) {
			data.state = Tango::FAULT;
			data.status = string(e.errors[0].desc);
		}

		// Copy data
		device->data_mutex.lock();
		device->data = data;
		device->data_mutex.unlock();
	}

	DEBUG_STREAM << "Worker::run_undetached() - exit" << endl;

	return NULL;
}

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::namespace_ending
} //	namespace
