/*----- PROTECTED REGION ID(Agilent4uhv.h) ENABLED START -----*/
//=============================================================================
//
// file :        Agilent4uhv.h
//
// description : Include file for the Agilent4uhv class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.9 $
// $Date: 2018-05-10 08:04:51 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Agilent4uhv_H
#define Agilent4uhv_H

#include <tango.h>
#include <Serial2Client.h>

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv.h

/**
 *  Agilent4uhv class description:
 *    
 */

namespace Agilent4uhv_ns
{
/*----- PROTECTED REGION ID(Agilent4uhv::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations
class Worker;
struct Data {
	string model;
	string serial_number;
	Tango::DevFloat temperature_fan;
	int hvch[4];
	Tango::DevLong device_number[4];
	Tango::DevUShort power_max[4];
	Tango::DevUShort vtarget[4];
	Tango::DevUShort iprotect[4];
	Tango::DevDouble setpoint[4];
	Tango::DevFloat temperaturehv[4];
	Tango::DevDouble vmeasured[4];
	Tango::DevDouble imeasured[4];
	Tango::DevDouble pressure[4];
	
	vector<unsigned char> autostart;
	vector<unsigned char> protect;
	vector<unsigned char> fs;
	vector<unsigned char> ssp;
	vector<unsigned char> is;
	vector<unsigned char> ec;

	Tango::DevState state;
	string status;
};

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::Additional Class Declarations

class Agilent4uhv : public Serial2Client_ns::Serial2Client
{

/*----- PROTECTED REGION ID(Agilent4uhv::Data Members) ENABLED START -----*/

//	Add your own data members
	Tango::DevUShort nchannel;
	string init_error;
	bool odd_channel_quirk;

	omni_mutex iomutex;

public:
	Worker *worker;
	Data data;
	omni_mutex data_mutex;

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::Data Members

//	Device property data members
public:

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevString	*attr_Model_read;
	Tango::DevString	*attr_SerialNumber_read;
	Tango::DevFloat	*attr_Temperature_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Agilent4uhv(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Agilent4uhv(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Agilent4uhv(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Agilent4uhv() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Agilent4uhv::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute Model related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Model(Tango::Attribute &attr);
	virtual bool is_Model_allowed(Tango::AttReqType type);
/**
 *	Attribute SerialNumber related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_SerialNumber(Tango::Attribute &attr);
	virtual bool is_SerialNumber_allowed(Tango::AttReqType type);
/**
 *	Attribute Temperature related methods
 *	Description: 
 *
 *	Data type:	Tango::DevFloat
 *	Attr type:	Scalar
 */
	virtual void read_Temperature(Tango::Attribute &attr);
	virtual bool is_Temperature_allowed(Tango::AttReqType type);

//	Dynamic attribute methods
public:

	/**
	 *	Attribute HVX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevState
	 *	Attr type:	Scalar
	 */
	virtual void read_HVX(Tango::Attribute &attr);
	virtual bool is_HVX_allowed(Tango::AttReqType type);
	void add_HVX_dynamic_attribute(string attname);
	void remove_HVX_dynamic_attribute(string attname);
	Tango::DevState *get_HVX_data_ptr(string &name);
	map<string,Tango::DevState>	   HVX_data;

	/**
	 *	Attribute DeviceNumberX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar
	 */
	virtual void read_DeviceNumberX(Tango::Attribute &attr);
	virtual void write_DeviceNumberX(Tango::WAttribute &attr);
	virtual bool is_DeviceNumberX_allowed(Tango::AttReqType type);
	void add_DeviceNumberX_dynamic_attribute(string attname);
	void remove_DeviceNumberX_dynamic_attribute(string attname);
	Tango::DevLong *get_DeviceNumberX_data_ptr(string &name);
	map<string,Tango::DevLong>	   DeviceNumberX_data;

	/**
	 *	Attribute PowerMaxX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar
	 */
	virtual void read_PowerMaxX(Tango::Attribute &attr);
	virtual void write_PowerMaxX(Tango::WAttribute &attr);
	virtual bool is_PowerMaxX_allowed(Tango::AttReqType type);
	void add_PowerMaxX_dynamic_attribute(string attname);
	void remove_PowerMaxX_dynamic_attribute(string attname);
	Tango::DevUShort *get_PowerMaxX_data_ptr(string &name);
	map<string,Tango::DevUShort>	   PowerMaxX_data;

	/**
	 *	Attribute VTargetX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar
	 */
	virtual void read_VTargetX(Tango::Attribute &attr);
	virtual void write_VTargetX(Tango::WAttribute &attr);
	virtual bool is_VTargetX_allowed(Tango::AttReqType type);
	void add_VTargetX_dynamic_attribute(string attname);
	void remove_VTargetX_dynamic_attribute(string attname);
	Tango::DevUShort *get_VTargetX_data_ptr(string &name);
	map<string,Tango::DevUShort>	   VTargetX_data;

	/**
	 *	Attribute IProtectX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar
	 */
	virtual void read_IProtectX(Tango::Attribute &attr);
	virtual void write_IProtectX(Tango::WAttribute &attr);
	virtual bool is_IProtectX_allowed(Tango::AttReqType type);
	void add_IProtectX_dynamic_attribute(string attname);
	void remove_IProtectX_dynamic_attribute(string attname);
	Tango::DevUShort *get_IProtectX_data_ptr(string &name);
	map<string,Tango::DevUShort>	   IProtectX_data;

	/**
	 *	Attribute SetPointX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_SetPointX(Tango::Attribute &attr);
	virtual void write_SetPointX(Tango::WAttribute &attr);
	virtual bool is_SetPointX_allowed(Tango::AttReqType type);
	void add_SetPointX_dynamic_attribute(string attname);
	void remove_SetPointX_dynamic_attribute(string attname);
	Tango::DevDouble *get_SetPointX_data_ptr(string &name);
	map<string,Tango::DevDouble>	   SetPointX_data;

	/**
	 *	Attribute TemperatureHVX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar
	 */
	virtual void read_TemperatureHVX(Tango::Attribute &attr);
	virtual bool is_TemperatureHVX_allowed(Tango::AttReqType type);
	void add_TemperatureHVX_dynamic_attribute(string attname);
	void remove_TemperatureHVX_dynamic_attribute(string attname);
	Tango::DevFloat *get_TemperatureHVX_data_ptr(string &name);
	map<string,Tango::DevFloat>	   TemperatureHVX_data;

	/**
	 *	Attribute VoltageX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_VoltageX(Tango::Attribute &attr);
	virtual bool is_VoltageX_allowed(Tango::AttReqType type);
	void add_VoltageX_dynamic_attribute(string attname);
	void remove_VoltageX_dynamic_attribute(string attname);
	Tango::DevDouble *get_VoltageX_data_ptr(string &name);
	map<string,Tango::DevDouble>	   VoltageX_data;

	/**
	 *	Attribute CurrentX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_CurrentX(Tango::Attribute &attr);
	virtual bool is_CurrentX_allowed(Tango::AttReqType type);
	void add_CurrentX_dynamic_attribute(string attname);
	void remove_CurrentX_dynamic_attribute(string attname);
	Tango::DevDouble *get_CurrentX_data_ptr(string &name);
	map<string,Tango::DevDouble>	   CurrentX_data;

	/**
	 *	Attribute PressureX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_PressureX(Tango::Attribute &attr);
	virtual bool is_PressureX_allowed(Tango::AttReqType type);
	void add_PressureX_dynamic_attribute(string attname);
	void remove_PressureX_dynamic_attribute(string attname);
	Tango::DevDouble *get_PressureX_data_ptr(string &name);
	map<string,Tango::DevDouble>	   PressureX_data;

	/**
	 *	Attribute StateX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevState
	 *	Attr type:	Scalar
	 */
	virtual void read_StateX(Tango::Attribute &attr);
	virtual bool is_StateX_allowed(Tango::AttReqType type);
	void add_StateX_dynamic_attribute(string attname);
	void remove_StateX_dynamic_attribute(string attname);
	Tango::DevState *get_StateX_data_ptr(string &name);
	map<string,Tango::DevState>	   StateX_data;

	/**
	 *	Attribute StatusX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevString
	 *	Attr type:	Scalar
	 */
	virtual void read_StatusX(Tango::Attribute &attr);
	virtual bool is_StatusX_allowed(Tango::AttReqType type);
	void add_StatusX_dynamic_attribute(string attname);
	void remove_StatusX_dynamic_attribute(string attname);
	Tango::DevString *get_StatusX_data_ptr(string &name);
	map<string,Tango::DevString>	   StatusX_data;

	/**
	 *	Attribute AutoStartX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_AutoStartX(Tango::Attribute &attr);
	virtual void write_AutoStartX(Tango::WAttribute &attr);
	virtual bool is_AutoStartX_allowed(Tango::AttReqType type);
	void add_AutoStartX_dynamic_attribute(string attname);
	void remove_AutoStartX_dynamic_attribute(string attname);
	Tango::DevBoolean *get_AutoStartX_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   AutoStartX_data;

	/**
	 *	Attribute ProtectX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_ProtectX(Tango::Attribute &attr);
	virtual void write_ProtectX(Tango::WAttribute &attr);
	virtual bool is_ProtectX_allowed(Tango::AttReqType type);
	void add_ProtectX_dynamic_attribute(string attname);
	void remove_ProtectX_dynamic_attribute(string attname);
	Tango::DevBoolean *get_ProtectX_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   ProtectX_data;

	/**
	 *	Attribute FixedStepX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_FixedStepX(Tango::Attribute &attr);
	virtual void write_FixedStepX(Tango::WAttribute &attr);
	virtual bool is_FixedStepX_allowed(Tango::AttReqType type);
	void add_FixedStepX_dynamic_attribute(string attname);
	void remove_FixedStepX_dynamic_attribute(string attname);
	Tango::DevBoolean *get_FixedStepX_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   FixedStepX_data;

	/**
	 *	Attribute StatusSetPointX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_StatusSetPointX(Tango::Attribute &attr);
	virtual bool is_StatusSetPointX_allowed(Tango::AttReqType type);
	void add_StatusSetPointX_dynamic_attribute(string attname);
	void remove_StatusSetPointX_dynamic_attribute(string attname);
	Tango::DevBoolean *get_StatusSetPointX_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   StatusSetPointX_data;

	/**
	 *	Attribute InterlockStatusX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_InterlockStatusX(Tango::Attribute &attr);
	virtual bool is_InterlockStatusX_allowed(Tango::AttReqType type);
	void add_InterlockStatusX_dynamic_attribute(string attname);
	void remove_InterlockStatusX_dynamic_attribute(string attname);
	Tango::DevBoolean *get_InterlockStatusX_data_ptr(string &name);
	map<string,Tango::DevBoolean>	   InterlockStatusX_data;

	/**
	 *	Attribute StatMaskX related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar
	 */
	virtual void read_StatMaskX(Tango::Attribute &attr);
	virtual bool is_StatMaskX_allowed(Tango::AttReqType type);
	void add_StatMaskX_dynamic_attribute(string attname);
	void remove_StatMaskX_dynamic_attribute(string attname);
	Tango::DevLong *get_StatMaskX_data_ptr(string &name);
	map<string,Tango::DevLong>	   StatMaskX_data;

	//--------------------------------------------------------
	/**
	 *	Method      : Agilent4uhv::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command OffHV1 related method
	 *	Description: 
	 *
	 */
	virtual void off_hv1();
	virtual bool is_OffHV1_allowed(const CORBA::Any &any);
	/**
	 *	Command OffHV2 related method
	 *	Description: 
	 *
	 */
	virtual void off_hv2();
	virtual bool is_OffHV2_allowed(const CORBA::Any &any);
	/**
	 *	Command OnHV1 related method
	 *	Description: 
	 *
	 */
	virtual void on_hv1();
	virtual bool is_OnHV1_allowed(const CORBA::Any &any);
	/**
	 *	Command OnHV2 related method
	 *	Description: 
	 *
	 */
	virtual void on_hv2();
	virtual bool is_OnHV2_allowed(const CORBA::Any &any);
	/**
	 *	Command OffHV3 related method
	 *	Description: 
	 *
	 */
	virtual void off_hv3();
	virtual bool is_OffHV3_allowed(const CORBA::Any &any);
	/**
	 *	Command OffHV4 related method
	 *	Description: 
	 *
	 */
	virtual void off_hv4();
	virtual bool is_OffHV4_allowed(const CORBA::Any &any);
	/**
	 *	Command OnHV3 related method
	 *	Description: 
	 *
	 */
	virtual void on_hv3();
	virtual bool is_OnHV3_allowed(const CORBA::Any &any);
	/**
	 *	Command OnHV4 related method
	 *	Description: 
	 *
	 */
	virtual void on_hv4();
	virtual bool is_OnHV4_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : Agilent4uhv::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Agilent4uhv::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
	void write(const int win, string &value);
	template<typename T> void write(const int win, T &value)
	{
		string data;
		convert(value, data);
		write(win, data);
	}

	void read(const int win, string &value);
	template<typename T> void read(const int win, T &value)
	{
		string answer;
		read(win, answer);
		convert(answer, value);
	}

	void write(const int win, vector<unsigned char> &data);
	void read(const int win, vector<unsigned char> &answer);
	void check_ack();
	void write_message(const string win_s, const unsigned char com, vector<unsigned char> &data);
	void read_answer(const string win_s, const unsigned char com, vector<unsigned char> &answer);
	unsigned char calc_crc(const vector<unsigned char> &message);
	template<typename F, typename T> void convert(const F &reply, T &reply_converted)
	{
		stringstream conv;
		convert(reply, conv);
		conv >> reply_converted;

		if (conv.fail())
			Tango::Except::throw_exception(
					"API_ConverionError",
					"Conversion fail " + conv.str(),
					"Agilent4uhv::convert()");
	}
	template<typename F> void convert(const F &reply, stringstream &conv)
	{
		conv << reply << flush;

		if (conv.fail())
			Tango::Except::throw_exception(
					"API_ConverionError",
					"Conversion fail " + conv.str(),
					"Agilent4uhv::convert()");
	}
	template<typename F> void convert(const F &reply, string &reply_converted)
	{
		stringstream conv;
		convert(reply, conv);
		reply_converted = conv.str();
	}
	void check_init_error(void);

/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Agilent4uhv::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions
class Worker : public omni_thread, public Tango::LogAdapter
{
	Agilent4uhv *device;
	void* run_undetached(void*);
	bool cont;

	public:
	void start(void) {
		start_undetached();
	}

	void stop(void) {
		cont = false;
	}

	void wait(unsigned int millisecs)
	{
		while(cont && millisecs) {
			if (millisecs >= 250) {
				omni_thread::self()->sleep(0, 250000000);
				millisecs -= 250;
			} else {
				omni_thread::self()->sleep(0, millisecs * 1000000);
				millisecs = 0;
			}
		}
	}

	Worker(Agilent4uhv *device_) :
		LogAdapter((Tango::DeviceImpl*)device_),
		device(device_) {
			cont = true;
		}
};


/*----- PROTECTED REGION END -----*/	//	Agilent4uhv::Additional Classes Definitions

}	//	End of namespace

#endif   //	Agilent4uhv_H
